within ;
model spring_mass
  // declaration part
  // "Real" is a type, "y" is its instance
  Real y;
  Real dy;
  Real f_spring;
  Real f_mass;
  Real v;
  Real a;
  Real hang;

  // parameters COULD have direct equation in declaration
  parameter Real k = 2;
  parameter Real m = 3;
// this is valid only during init phase
initial equation
  y = 1;

// this holds forever
// note those are REALLY equations
equation

  // thats where the spring is hanged to
  hang = 0;

  // length difference
  dy = y - hang;

  f_spring = k * dy;
  f_mass = m * a;

  // we could not do double derivative as a=der(der(y))
  a = der(v);
  v = der(y);

  // forces must sum up to 0 - (Kirchhoff) at the point of connection
  f_spring + f_mass = 0;

  annotation(Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})), Diagram(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})),
    uses(Modelica(version="3.2")));

end spring_mass;
